__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a8"
__cvsversion__ = "$Revision: 1.13 $"
__date__       = "$Date: 2004/11/09 15:12:28 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rApp.py,v 1.13 2004/11/09 15:12:28 asc Exp $

from wxPython.wx import *
from rConstants  import *
from rDisplay    import rDisplay
from rPrefs      import rPrefs
from rError      import rNoService

from time        import sleep

class rApp(wxApp):

    def OnInit(self):

        wxInitAllImageHandlers()

        frame = rDisplay(NULL, ID_APP, TITLE_APP)
        frame.Setup()

	self.Run(frame)
	return True

    #
    
    def Run (self,frame):

        self.SetTopWindow(frame)        

        #

        no_service = False
                    
        while frame and frame.Panel :
            
	    if frame.Paused == true:
                wxSafeYield(frame,true)
            else:
                
                try :
                    frame.DisplayRandom()
                                    
                except rNoService, inst :                    
                    if no_service == False :
                        no_service = True

                        wxYield()
                        
                        prefs = rPrefs(frame,-1,frame.LoadConfig())                        
                        (x,y) = frame.GetPosition()
                        prefs.SetPosition((x + 50,y + 50))
                        
                        prefs.Show()

                    wxYield()
                        
                else :
                    pass
                
                self.pause(frame)                

    #
    
    def pause (self, frame) :
        for i in range(COUNTER_DELAY):
            sleep(SECONDS_SLEEP)
            
            if frame and frame.Panel:
                if frame.Paused == true:
                    break
                else:
                    wxYield()
            else:
                break               
        
if __name__ == "__main__" :
   app = rApp()
   app.MainLoop()
